<%
##
## Changes users passwords in the registry
##
## Fields required:
##   user
##   pw1
##   pw2
##   branch

zap::getrequest { user pw1 pw2 branch }

## Go for it
if { $asp::input(pw1) != $asp::input(pw2) } {
    zap::error "Supplied passwords are different, 
    not altering admin passwd";
}

if { [llength $asp::input(pw1) ] == 0 } {
    zap::error "Blank passwords are not allowed"
}

# Attempt to set it
reg::setbase $asp::input(branch)
if { [ catch { reg::add $asp::input(user) $asp::input(pw1) "encrypted" 
             } result ] } {
    zap::error "Update failed: $result"
}

asp::redirect "/apps/admin"

%>
