<%
zap::getrequest { server }
set server $asp::input(server)
%>

<html>
<head>
<title><%= $server %> - Edit server</title>
</head>

<body bgcolor="#ffffff" link=#990066 vlink=#990066 alink=#990066>

<table>
<tr>
 <td valign=top>
  <img src="/apps/web/title.gif" hspace=10 alt="">
  <p align=right>
  <a href="/apps/admin/docsystem/" target="help" onClick=
    "window.open('','help','resizable=1,width=640,height=500'); return true;">
  <img src="/apps/web/docs.gif" 
   alt="[docs]" align=bottom border=0 hspace=0></a>
  <a href="/apps/web/"><img src="/apps/web/back.gif" 
  alt="[back]" align=bottom border=0 hspace=0></a>
  <a href="/apps/web/"><img src="/apps/web/home.gif" alt="[Controller]" 
   align=bottom border=0></a>
  </td>
  <td valign=top>

<table>
<tr>
  <td>
  <img src="/apps/web/title-editserver.gif" 
       alt="Edit Server <%= $server %>">
  </td>
</tr>
<tr>
  <td align=right>
  Server: <b><%=$server%></b>
  </td>
</tr>
</table>

<p>
<table>
<! standard ones first >
<center>
<tr>
  <td>
    <center>
    <a href="/apps/web/general.asp?server=<%= $server %>"
     ><img src="button-advanced.gif" border=0 alt="" hspace=5></a>
    </center>
  </td>
  <td>
    <center>
    <a href="/apps/web/ssl.asp?server=<%= $server %>"
     ><img src="button-security.gif" border=0 alt="" hspace=5></a>
    </center>
  </td>
  <td>
    <center>
    <a href="/apps/web/modules.zap?server=<%= $server %>"
     ><img src="button-modules.gif" border=0 alt="" hspace=5></a>
    </center>
  </td>
  <td>
    <center>
    <a href="/apps/web/del1.asp?server=<%= $server %>"
     ><img src="button-delete.gif" border=0 alt="" hspace=5></a>
    </center>
  </td>
</tr>

<tr>
   <td>
     <font size=-1><center>
     <a href="/apps/web/general.asp?server=<%= $server %>">
     General<br>Configuration</a><br>
     </center></font>
   </td>
   <td>
     <font size=-1><center>
     <a href="/apps/web/ssl.asp?server=<%= $server %>">
     SSL<br>Configuration</a><br>
     </center></font>
   </td>
   <td>
     <font size=-1><center>
     <a href="/apps/web/modules.zap?server=<%= $server %>">
     Module<br>Configuration</a><br>
     </center></font>
   </td>
   <td>
     <font size=-1><center>
     <a href="/apps/web/del1.asp?server=<%= $server %>">
     Delete<br>server <%= $server %></a><br>
     </center></font>
   </td>
</tr>
</table>

</center>

<! now the modules that are active >

<p><b><font size=+1>Module Configurables</font></b><p>

<dl>
<dd>
<%
## Now we need to work out which modules that are active have useful
## configuration so we can give them a button

set base "conf!web!servers!$server!modules"
foreach item [lsort -dictionary [zap::reglist $base]] {
    # Lets work out if this guy is enabled
    if { [zap::regget "$base!$item!enabled" ] != "yes" } { continue }

    # Now lets see if it has a link file that has LINK_HAVECONFIG set (bit 1)
    #
    # Format for a link file
    # 1st line: 32bit int comprising of flags defined below
    # 2nd line: href to module configuration page
    # 3rd line: Long description
    #
    # Flags are: 
    #    Have a useful configuration page                        : bit 1
    #    Am an inportant module that you don't want to turn off! : bit 2

    set filename "$request::env(ZEUSHOME)/docroot/apps/web/modules/$item/link"
    if [catch {server::cache $filename} content ] { continue }
    set lines [split $content \n]
    set flags [lindex $lines 0]
    set href  [lindex $lines 1]
    set desc  [lindex $lines 2]
    if { [ expr $flags & 1 ] == 0 }  { continue }

    # OK, its a file we want to display
    
    # Add a graphic, and a link to the given href + [?|&]server=$server
    if { [ string first "?" $href ] == -1 } { 
	append href "?"
    } else {
	append href "&"
    }
    append href "server=$server"
    asp::write "\n
    <a href=\"$href&back=$request::env(SCRIPT_NAME)?$request::env(QUERY_STRING)
    \">
    <img src=\"modules/$item/icon.gif\" border=0 vspace=1 hspace=1 
    alt=\"$desc\"></a>";
}


##
## Now check if the modified flag is set, and if so, provide a link to
## restart the website (if the webserver is running)
##


if { [zap::regget "conf!web!servers!$server!modified" ] == "yes" } {
    # non-zero if any webserver processes are alive
    set webserver_alive 0

    # Attempt to get secret key if available
    set secret ""
    catch { set secret [read [open "$request::env(ZEUSHOME)/web/etc/secret"]] }

    # Work out what's alive and what's running
    set runningservers [zap::reglist dynamic!apps!web]
    if { [llength $runningservers] > 0 } {
	# We just look at the first one in the non cluster case
	set host [lindex $runningservers 0]
	set port [zap::regget "dynamic!apps!web!$host"]
	# Try to connect to host:port to work out what its running
	catch { 
	    set s [ socket $host $port ]
	    puts $s "${secret}info\n"; flush $s
	    set data [ read $s ]
	    # the command worked, so this webserver must be alive...
	    incr webserver_alive
	}
    } else {
	# No webserver processes are running
    }

    if { $webserver_alive != 0 } {
	asp::write "<p>Configuration changes have been made. Click ";
	asp::write "<a href=\"website.zap?website=$server&action=restart\"> "
	asp::write "here</a> to (re)start server $server";
    }
}

%>

</dl>

%>


<%
asp::include etc/footer.html
%>
