<! Required variables
   server
>
$$set help=/apps/web/docs/modules/access/index.html;
$$set _base=conf!web!servers!$$server;!modules!access;
$$set back=/apps/web/edit.zap?server=$$server;;
<title>$$server; - Access Rules</title>

$$set edittitle=Access Rules;
$$include /../header.asp;


<p><hr size=1 width=80%>

<dl>
<dt><font size=+1><b>Current Rules</b></font>
<dd>

<p>
Access control rules allow you to restrict access to parts of your website.
You can set restrictions based on the address or name of the remote machine, 
or based upon usernames and passwords.  On each requests, the rules are 
processed in order.  If all the fields match the request, then that rule will
apply. Click on the rule number to edit the rule.
<p>

$$if rules=yes;
    <table border=3>
	<tr>	
	   <td></td>
	   <td><b>Rule</td>
	   <td><b>Type</td>
	   <td><b>URL</td>
	   <td><b>Hostnames</td>
	   <td><b>IP Addresses</td>
	   <td><b>Users</td>
	   <td><b>Groups</td>
	</tr>
    $$for i in rules;
	<tr>
	<td>
	<a href="up.zap?server=$$server;&rule=$$i;">$$up;</a>
	$$set up=^;
	</td>
	<td><center><a href="editrule.asp?server=$$server;&rule=$$i;&back=rules.asp?server=$$server;">$$i;</a></td>
	<td>$$rules!$$i;!type;</td>
	<td>$$rules!$$i;!url;&nbsp;</td>
	<td>$$rules!$$i;!hosts;&nbsp;</td>
	<td>$$rules!$$i;!ips;&nbsp;</td>
	<td>
	$$for j in rules!$$i;!users;
		$$set _base=conf!web!servers!$$server;!modules!access!users;
		$$ifreg $$j;;
			$$j;
		$$else;
			<font color=red>$$j;</font>
		$$endif;

	$$next;
	&nbsp;
	$$set _base=conf!web!servers!$$server;!modules!access;
	</td>
	<td>
	$$for j in rules!$$i;!groups;
		$$set _base=conf!web!servers!$$server;!modules!access!groups;
		<!-- Can't do font red stuff because of the group all, which
	             always exists but wont be in registry -->
		$$j;
	$$next;
	&nbsp;
	</td>
	$$set _base=conf!web!servers!$$server;!modules!access;	
	</tr>
    $$next;
    </table>
$$else;
  <ul><i>No rules defined</i></ul>
$$endif;
<p>
<a href="newrule.zap?server=$$server;">Create a new rule</a>
$$if rules=yes;
	&nbsp;&nbsp;&nbsp;&nbsp;<a href="testrules.asp?server=$$server;&url=/">
	Test rules</a>
$$endif;
</dl>

<p><hr size=1 width=80%>
<dl>
<dt><font size=+1><b>User Management</b></font>
<dd>
<p>
<a href="users.asp?server=$$server;">Configure users</a><br>
<a href="groups.asp?server=$$server;">Configure groups</a>
</dl>

<p><hr size=1 width=80%>
<dl>
<dt><font size=+1><b>Verbose mode</b></font>
<dd>

Enables extra verbose logging to the webserver error log file
(generally <tt>/usr/local/zeus/log/web</tt>) which can aid debugging
access control rules.  Note enabling this option can generate a lot of
trace info, and shouldn't be enabled for a 'live' site.

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name="_base" value="$$_base;">
<input type=hidden name=_redirect value="$$back;">
<input type=hidden name=_add_boolean_verbose value=no>
Verbose mode:
<input type=checkbox name=_add_boolean_verbose value=yes $$if verbose=yes;checked$$endif;>
<input type=submit value="Update">
</dl>


$$include /../footer.asp;


