<! Required variables
   server
>
$$set help=/apps/web/docs/controller/controller.html%23general;
$$set _base=conf!web!servers!$$server;;
$$set back=/apps/web/edit.zap?server=$$server;;

<title>$$server; - General Server Configuration</title>

$$include /etc/header.asp;

$$set edittitle=General Server Configuration;
$$include /editheader.html;

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name="_base" value="$$_base;">
<input type=hidden name=_redirect value="$$back;">

<dl>
<dt><font size=+1><b>Server URL</b></font>
<dd>
  The address of the server, as it would be in a URL. 
  <br>
  (e.g. www.mysite.com, or www.mysite.com:8000) 
  <br>
  <input name=_add_text_ip_name text=text size=30 value="$$ip_name;"> :
  <input name=_add_integer_port type=text value="$$port;" size=5>


<p><dt><font size=+1><b>Document Root</b></font>
<dd>
  The directory under which all the web pages are stored<br>
  <input name=_add_text_docroot type=text value="$$docroot;" size=40>
<p>

<p><dt><font size=+1><b>Webmaster e-mail address</b></font>
<dd>
   Here you can specify the e-mail address of the person responsible
   for this website.  Any error pages send to a client, such as 'File
   not found', will contain this e-mail address.  If no address is
   specified, Zeus will take a good guess.<br>

   <input name=_add_text_webmaster type=text value="$$webmaster;"
   size=40>
<p>

<dt><font size=+1><b>DNS Lookup</b></font>
<dd>

DNS lookup maps IP addresses to host names. This makes it easier to
see where people are accessing your pages from. It is also required to
do domain restricted access control. However, DNS does add a small
performance overhead and you can disable it if you wish.
<p>

<dl>
<dd>

<input type=radio value=yes name=_add_boolean_dnslookup
 $$if dnslookup=yes; checked=yes; $$endif; > Perform DNS lookup
<br>
<input type=radio value=no name=_add_boolean_dnslookup
 $$if dnslookup=no; checked=yes; $$endif; > No DNS lookup

</dl>
<p>

<dt><font size=+1><b>Error logging</b></font>
<dd>

This setting specifies the filename where any error information
generated by the virtual server will be logged.  Note this does not
include error information concerning starting / stopping the virtual
server, which is always logged to the global log file.  If the
filename is left blank, then all errors will be logged to the global
logfile.

<p>
<input type=text name=_add_text_errlog value="$$errlog;" size=30>
<p>


<dt><font size=+1><b>Soft-virtual server aliases</b></font>
<dd>

This setting only has any effect when this server is a 'soft-virtual
server'.  See the documentation system for more information.
The aliases are seperated by spaces.  If a <tt>*</tt> will map any
<tt>Host</tt> headers not taken by the other soft-virtual servers to
this virtual server.

<p>
<input type=text name=_add_text_aliases value="$$aliases;" size=30>
<p>

<dt><font size=+1><b>External Website Location</b></font>
<dd>

Sometimes you may need to bind a website to one ip-address:port, but
actually make the server think its running on a completely different
ip-address:port.  For example, imagine the case where the webserver is
running behind a firewall which is configured to forward web-requests
to an internal IP-address.  Here the website address 'www.mysite.com'
is an IP-address associated with the firewall, not the backend
webserver behind the firewall (which is probably running on an
internal 10.* subnet). <p>

Specifying an external ipname or port (or both) alters any
self-referential URLs generated by the webserver (e.g. for a HTTP
redirect).  In this example, you would specify the server URL above to
be '10.x.x.x' and set the external name in the field below to
'www.mysite.com'. <p>

<i>(most people never need to use this setting).</i>
<p>

<table>
  <tr>
    <td>External website name:</td>
    <td>
    <input type=text name=_add_text_external_ipname value="$$external_ipname;"
      size=30>
    </td>
  </tr>
  <tr>

    <td>External website port:</td>
    <td>
    <input type=text name=_add_text_external_port
    value="$$external_port;" size=5>
    </td>
  </tr>
</table>


</dl>

<p>
<input type=submit value=Update>
</form>


$$include /etc/footer.html;
