#!/bin/sh

while [ 1 ] 
do
    printf "Enter Zeus installation directory: "
    read ZEUSHOME

    if [ ! -x $ZEUSHOME/bin/regcmd ]
    then
	echo "Supplied zeus install directory is incorrect"
    else
        break
    fi
done
    
printf "Enter licence key: "
read KEY
printf "Enter admin password: "
stty -echo
read PASS
stty echo
echo



# ----------------------------------------------------------
# Work out full hostname in Zeus approved manner 

MACHINE=`hostname`
# do we have any '.' in the hostname?
echo $MACHINE | grep "\." 2>&1 > /dev/null

if [ $? -ne 0 ]
then
    DOMAIN=`cat /etc/resolv.conf | awk '/domain/ { print $2; }'`
    if [ ! -z "$DOMAIN" ]
    then
        MACHINE=$MACHINE.$DOMAIN
    else
	DOMAIN=`domainname`
	if [ ! -z "$DOMAIN" -a "$DOMAIN" != "(none)" ]
	then 
	    MACHINE=$MACHINE.$DOMAIN
	fi
    fi
fi
echo Resolved machine name as "$MACHINE"

# ----------------------------------------------------------


echo 'set conf!packages!'$MACHINE'!web!key ' $KEY |
    $ZEUSHOME/bin/regcmd -user admin -pass "$PASS" -

if [ $? -eq 0 ]
then
    echo "Success: restart the webserver for change to take effect."
else
    echo "Failure: unable to update licence key"
    exit 1
fi


